indexing
	description: "Automated control objects"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	AUTOMATED_OBJECT

feature -- Initalization
	make (a: AUTO; co: CONTROL_OBJECT) is
			-- Set `a' as `controller' and `co' as `comuter'
		require
			auto_exists: a /= Void
			control_object_exists: co /= Void
			predicate_count_same: a.predicate_count = co.predicate_count
			action_count_same: a.action_count = co.action_count
		do
			controller := a
			computer := co
		end

feature -- Basic Operations
	restart is
			-- Bring controller and computer to initial state
		do
			controller.restart
			computer.restart
		end

	do_step is
			-- Do control and computing (or emulation)
		do
			controller.do_transition (computer.predicate_values)
			computer.do_actions (controller.actions)
			computer.do_step
		end

feature -- Output
	show_computational_state is
			-- Show computer's computational state
		do
			computer.show_computational_state
		end
	get_controller: AUTO is
		do
			Result := controller
		end
	get_computer: CONTROL_OBJECT is
		do
			Result := computer
		end

feature {NONE} -- Implementation
	controller: AUTO
	computer: CONTROL_OBJECT

invariant
	controller_exists: controller /= Void
	computer_exists: computer /= Void
	predicate_count_same: controller.predicate_count = computer.predicate_count
	action_count_same: controller.action_count = computer.action_count
end
