indexing
	description: "Finite precision equality and comparison for reals"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	REAL_COMPARISON

feature -- Access
	precision: REAL is 0.1e-5
			-- Default precision

feature -- Basic operations
	approx_equal (x, y: REAL): BOOLEAN is
			-- Is `x' approximately equal to `y'?
		do
			if y = 0.0 then
				Result := x.abs <= precision
			else
				Result := (1.0 - x / y).abs <= precision
			end
		end

	approx_less (x, y: REAL): BOOLEAN is
			-- Is `x' less than `y' at least by `precision'?
		do
			if y = 0.0 then
				Result := x < precision
			else
				Result := (y.sign - x / y.abs) > precision
			end
		end

	approx_less_equal (x, y: REAL): BOOLEAN is
			-- Is `x' less than or approximately equal to `y'?
		do
			Result := (x < y) or approx_equal(x, y)
		end
end
